<script>
	import { dataStore, selected_issue_timetag } from '../stores/dataProductStore.js';
	import mousePosition from '../stores/mousePosition.js';

	import ForecastPlot from './ForecastPlot.svelte';
	import BarPlot from './BarPlot.svelte';
	import AreaPlot from './AreaPlot.svelte';
	import LinePlot from './LinePlot.svelte';
	export let plotElement;
	export let data;
	export let xScale;
	export let yScale;

	// Move this code to the datastore, so that it is not unnecesarily repeated if a forecast contains multiple plot elements.
	let unique_issue_timetags;
	$: issue_timetags = data.map(a => a.timetag_issue);
	$: {
		unique_issue_timetags = [... new Set(issue_timetags)];
	}
	$: {
		if (!(plotElement.dataset in $selected_issue_timetag)) {
			$selected_issue_timetag[plotElement.dataset] = unique_issue_timetags.at(-1);
		}
	}

	function onKeyDown(e) {
		if ($mousePosition.y >= yScale.range()[1] && $mousePosition.y <= yScale.range()[0]) {
			let index = unique_issue_timetags.indexOf($selected_issue_timetag[plotElement.dataset]);
			let new_index = index;
			switch(e.keyCode) {
				case 37: // Left-arrow
					new_index = index - 1;
					break;
				case 39: // Right-arrow
					new_index = index + 1;
					break;
			}
			if (new_index < 0) { new_index = 0; }
			if (new_index > unique_issue_timetags.length - 1) { new_index = unique_issue_timetags.length - 1; }
			$selected_issue_timetag[plotElement.dataset] = unique_issue_timetags[new_index];
		}
	}

</script>

{#if "issue_time_parameter" in plotElement}
	<ForecastPlot {plotElement} data={data} {xScale} yScale={yScale}/>
{:else if plotElement.plot_options.plot_type == "bars"}
	<BarPlot {plotElement} data={data.filter(function(d) { return d.timetag_issue==$selected_issue_timetag[plotElement.dataset]} )} cadence={$dataStore[plotElement.dataset].cadence} xScale={xScale} yScale={yScale}/>
{:else if plotElement.plot_options.plot_type == "area"}
	<AreaPlot {plotElement} data={data.filter(function(d) { return d.timetag_issue==$selected_issue_timetag[plotElement.dataset]} )} {xScale} yScale={yScale}/>
{:else if plotElement.plot_options.plot_type == "line"}
	<LinePlot {plotElement} data={data.filter(function(d) { return d.timetag_issue==$selected_issue_timetag[plotElement.dataset]} )} {xScale} yScale={yScale}/>
{/if}

{#each unique_issue_timetags as d}
	{#if d == $selected_issue_timetag[plotElement.dataset]}
		<!-- Selected prediction indicator -->
		<circle cx="{xScale(new Date(d))}"
				cy="{yScale.range()[0]}"
				r="4"
				fill="indianred"
				stroke-width="2"
				stroke="black"/>
		<line x1="{xScale(new Date(d))}"
			  x2="{xScale(new Date(d))}"
			  y1={yScale.range()[0]}
			  y2={yScale.range()[1]}
			  stroke-width="2"
			  stroke="indianred"/>
	{:else}
		<!--  -->
		<!-- Unselected prediction indicator -->
		<circle cx="{xScale(new Date(d))}"
				cy="{yScale.range()[0]}"
				r="4"
				fill="white"
				fill-opacity="0%"
				stroke="black"
				stroke-width="1"/>
		<!-- Larger invisible click target -->
		<circle cx="{xScale(new Date(d))}"
				cy="{yScale.range()[0]}"
				r="25"
				fill="white"
				fill-opacity="0%"
				stroke="black"
				stroke-width="0"
				stroke-opacity="0%"
				on:click="{function() { $selected_issue_timetag[plotElement.dataset] = d}}"/>
	{/if}
{/each}
<svelte:window on:keydown={onKeyDown} />
